Index: channels/chan_sip.c
===================================================================
--- channels/chan_sip.c	(revision 233691)
+++ channels/chan_sip.c	(working copy)
@@ -22716,11 +22716,10 @@
 
 	/* New SIP request coming in
 	   (could be new request in existing SIP dialog as well...)
-	 */			
-	
-	p->method = req->method;	/* Find out which SIP method they are using */
-	ast_debug(4, "**** Received %s (%d) - Command in SIP %s\n", sip_methods[p->method].text, sip_methods[p->method].id, cmd);
+	 */
 
+	ast_debug(4, "**** Received %s (%d) - Command in SIP %s\n", sip_methods[req->method].text, sip_methods[req->method].id, cmd);
+
 	if (p->icseq && (p->icseq > seqno) ) {
 		if (p->pendinginvite && seqno == p->pendinginvite && (req->method == SIP_ACK || req->method == SIP_CANCEL)) {
 			ast_debug(2, "Got CANCEL or ACK on INVITE with transactions in between.\n");
@@ -22733,14 +22732,14 @@
 	} else if (p->icseq &&
 		   p->icseq == seqno &&
 		   req->method != SIP_ACK &&
-		   (p->method != SIP_CANCEL || p->alreadygone)) {
+		   (req->method != SIP_CANCEL || p->alreadygone)) {
 		/* ignore means "don't do anything with it" but still have to
 		   respond appropriately.  We do this if we receive a repeat of
 		   the last sequence number  */
 		req->ignore = 1;
-		ast_debug(3, "Ignoring SIP message because of retransmit (%s Seqno %d, ours %d)\n", sip_methods[p->method].text, p->icseq, seqno);
+		ast_debug(3, "Ignoring SIP message because of retransmit (%s Seqno %d, ours %d)\n", sip_methods[req->method].text, p->icseq, seqno);
 	}
-		
+
 	if (seqno >= p->icseq)
 		/* Next should follow monotonically (but not necessarily
 		   incrementally -- thanks again to the genius authors of SIP --
@@ -22776,14 +22775,14 @@
 		}
 	}
 
-	if (!e && (p->method == SIP_INVITE || p->method == SIP_SUBSCRIBE || p->method == SIP_REGISTER || p->method == SIP_NOTIFY)) {
+	if (!e && (req->method == SIP_INVITE || req->method == SIP_SUBSCRIBE || req->method == SIP_REGISTER || req->method == SIP_NOTIFY)) {
 		transmit_response(p, "400 Bad request", req);
 		sip_scheddestroy(p, DEFAULT_TRANS_TIMEOUT);
 		return -1;
 	}
 
 	/* Handle various incoming SIP methods in requests */
-	switch (p->method) {
+	switch (req->method) {
 	case SIP_OPTIONS:
 		res = handle_request_options(p, req);
 		break;
